> For the complete documentation index, see [llms.txt](https://docs.proudnet.com/proudnet.eng/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.proudnet.com/proudnet.eng/proudnet-note/notes/error_message_list.md).

# List of error messages

## List of error codes

<table data-full-width="false"><thead><tr><th width="355">Error codes</th><th>Description</th></tr></thead><tbody><tr><td>ErrorType_Ok</td><td>Success</td></tr><tr><td>ErrorType_Unexpected</td><td>Exception raised</td></tr><tr><td>ErrorType_AlreadyConnected</td><td>Already connected</td></tr><tr><td>ErrorType_TCPConnectFailure</td><td>TCP connection failure</td></tr><tr><td>ErrorType_InvalidSessionKey</td><td>Invalid key</td></tr><tr><td>ErrorType_EncryptFail</td><td>Encoding failure</td></tr><tr><td>ErrorType_DecryptFail</td><td>Hackers sent corrupted data or failed to decode it</td></tr><tr><td>ErrorType_ConnectServerTimeout</td><td>Server connection timeout</td></tr><tr><td>ErrorType_ProtocolVersionMismatch</td><td>Different protocol versions for connecting to the server</td></tr><tr><td>ErrorType_InvalidLicense</td><td>Invalid licenses</td></tr><tr><td>ErrorType_NotifyServerDeniedConnection</td><td>Server intentionally refuses connection</td></tr><tr><td>ErrorType_Reserved01</td><td>Successful server connection</td></tr><tr><td>ErrorType_DisconnectFromRemote</td><td>Communication host disconnected</td></tr><tr><td>ErrorType_DisconnectFromLocal</td><td>Host disconnected</td></tr><tr><td>ErrorType_Reserved02</td><td>There are factors that can lead to dangerous situations</td></tr><tr><td>ErrorType_UnknownAddrPort</td><td>Unknown Internet address</td></tr><tr><td>ErrorType_Reserved03</td><td>Insufficient server preparation</td></tr><tr><td>ErrorType_ServerPortListenFailure</td><td>Unable to start receiving server socket. Make sure that the TCP or UDP socket is already a port in use.</td></tr><tr><td>ErrorType_AlreadyExists</td><td>Objects that already exist</td></tr><tr><td>ErrorType_PermissionDenied</td><td>Inaccessible</td></tr><tr><td>ErrorType_BadSessionGuid</td><td>Invalid Session Guid</td></tr><tr><td>ErrorType_InvalidCredential</td><td>Invalid credentials</td></tr><tr><td>ErrorType_InvalidHeroName</td><td>Invalid Hero Name</td></tr><tr><td>ErrorType_Reserved06</td><td>Problems after unlocked loading is locked</td></tr><tr><td>ErrorType_Reserved07</td><td>The output parameter, adjustedGamerIDNotFilled, is empty.</td></tr><tr><td>ErrorType_Reserved08</td><td>The player character does not exist.</td></tr><tr><td>ErrorType_UnitTestFailed</td><td>Unit test failure</td></tr><tr><td>ErrorType_P2PUdpFailed</td><td>P2P UDP communication is blocked.</td></tr><tr><td>ErrorType_ReliableUdpFailed</td><td>Reliable Udp failure</td></tr><tr><td>ErrorType_ServerUdpFailed</td><td>Client-server UDP communication is blocked.</td></tr><tr><td>ErrorType_NoP2PGroupRelation</td><td>There are no more P2P groups to belong to together.</td></tr><tr><td>ErrorType_ExceptionFromUserFunction</td><td>A user-defined function (RMI receiving routine or event handler) throws an exception</td></tr><tr><td>ErrorType_UserRequested</td><td>Errors due to user requests</td></tr><tr><td>ErrorType_InvalidPacketFormat</td><td>Invalid packet type. The communication host has been hacked or there is a bug.</td></tr><tr><td>ErrorType_TooLargeMessageDetected</td><td>Message size is large.</td></tr><tr><td>ErrorType_Reserved09</td><td>Untrusted messages cannot be encrypted.</td></tr><tr><td>ErrorType_ValueNotExist</td><td>Non-existent values</td></tr><tr><td>ErrorType_TimeOut</td><td>Timeout</td></tr><tr><td>ErrorType_LoadedDataNotFound</td><td>The loaded data was not found.</td></tr><tr><td>ErrorType_SendQueueIsHeavy</td><td>The transfer queue is too large.</td></tr><tr><td>ErrorType_TooSlowHeartbeatWarning</td><td>HeartBeat is slower than average.</td></tr><tr><td>ErrorType_CompressFail</td><td>Message Compression Failure</td></tr><tr><td>ErrorType_LocalSocketCreationFailed</td><td>The client socket could not be received or UDP could not be prepared. Need to check if there is a limit to the number of sockets per process and if TCP or UDP sockets are in use</td></tr><tr><td>Error_NoneAvailableInPortPool</td><td>Failed to bind to a local port in the Port Pool. Make sure the Port Pool value is sufficient.</td></tr><tr><td>ErrorType_InvalidPortPool</td><td>Invalid port range. Set the ports to 0 (random port binding) or check for duplicates.</td></tr><tr><td>ErrorType_InvalidHostID</td><td>Invalid HostID</td></tr><tr><td>ErrorType_MessageOverload</td><td>Messages accumulate faster than they can be processed. Check whether you are sending too many messages or whether your message processing routines are running too slowly.</td></tr><tr><td>ErrorType_DatabaseAccessFailed</td><td>DB access failed. You can see more details in the comment variable.</td></tr><tr><td>ErrorType_OutOfMemory</td><td>Low memory</td></tr><tr><td>ErrorType_AutoConnectionRecoveryFailed</td><td>The connection to the server was lost and the connection recovery feature was activated but failed.</td></tr></tbody></table>

## Comment message list

<table data-full-width="false"><thead><tr><th width="210">Message</th><th width="199.33333333333337">Error codes</th><th>Description</th></tr></thead><tbody><tr><td>%d bytes in send queue</td><td>ErrorType_SendQueueIsHeavy</td><td>When the transmission queue is full of too many messages, it notifies the full capacity. OnWarning occurs</td></tr><tr><td>(AddrPort) is not an IPv4 address</td><td>ErrorType_UnknownAddrPort</td><td>Address acquisition fails when converting to IPv4 addresses</td></tr><tr><td>Bad format in NotifyServerConnectSuccess</td><td>ErrorType_InvalidPacketFormat</td><td>Failed to connect to the server after sending a connection request from the client to the server</td></tr><tr><td>Before OnJoinServerComplete with fail, we got DNS lookup failure. Error=d</td><td>ErrorType_Unexpected</td><td>DNS lookup fails while connecting from client to server</td></tr><tr><td>blocked method but no active event</td><td>ErrorType_Unexpected</td><td>OnWarning Raised When DBCache2 Server Responds to DBCache2 Client</td></tr><tr><td>BlockedAddData failed! Call is bug in UserWorkerThread</td><td>ErrorType_Unexpected</td><td>Call fails on DBCache2 client</td></tr><tr><td>BlockedAddData failed! NodeData that confronts OwnerUUID cannot be found.</td><td>ErrorType_BadSessionGuid</td><td>AddData Failed on DBCache2 Client</td></tr><tr><td>BlockedAddData failed! NodeData that confronts RootUUID cannot be found.</td><td>ErrorType_BadSessionGuid</td><td>AddData Failed on DBCache2 Client</td></tr><tr><td>BlockedRecursiveUpdateData failed! Call is bug in UserWorkerThread!</td><td>ErrorType_Unexpected</td><td>RemoveData Failed on DBCache2 Client</td></tr><tr><td>BlockedRecursiveUpdateData failed! NodeData that confronts RootUUID cannot be found.</td><td>ErrorType_BadSessionGuid</td><td>RecursiveUpdateData fails on DBCache2 client</td></tr><tr><td>BlockedRemoveData failed! Call is bug in UserWorkerThread!</td><td>ErrorType_Unexpected</td><td>RemoveData Failed on DBCache2 Client</td></tr><tr><td>BlockedRemoveData failed! NodeData that confronts RootUUID cannot be found.</td><td>ErrorType_BadSessionGuid</td><td>RemoveData Failed on DBCache2 Client</td></tr><tr><td>BlockedRemoveData failed! NodeData that confronts UUID cannot be found.</td><td>ErrorType_BadSessionGuid</td><td>RemoveData Failed on DBCache2 Client</td></tr><tr><td>BlockUpdateData failed! Call is bug in UserWorkerThread!</td><td>ErrorType_Unexpected</td><td>UpdateData Failed on DBCache2 Client</td></tr><tr><td>BlockUpdateData failed! NodeData that confronts RootUUID cannot be found.</td><td>ErrorType_BadSessionGuid</td><td>UpdateData Failed on DBCache2 Client</td></tr><tr><td>BlockUpdateData failed! NodeData that confronts UUID cannot be found.</td><td>ErrorType_BadSessionGuid</td><td>UpdateData Failed on DBCache2 Client</td></tr><tr><td>Cannot bind TCP socket to a local address!</td><td>ErrorType_TCPConnectFailure</td><td>When the client fails to create a socket to connect to the server, the connection fails and OnError occurs.</td></tr><tr><td>Cannot send messages unless connection to server exists!</td><td>ErrorType_PermissionDenied</td><td>When sending a message while disconnected from the server, message transmission fails and OnError occurs.</td></tr><tr><td>Certification Failed to DB Cache</td><td>ErrorType_InvalidSessionKey</td><td>Client connection fails when responding to a client on the DBCache2 server</td></tr><tr><td>checksum failure.</td><td>ErrorType_DecryptFail</td><td>Failed to decrypt ByteArray or message</td></tr><tr><td>Connected to server successfully, but we cannot get DNS lookup. ErrorCode:d</td><td>ErrorType_Unexpected</td><td>OnError occurs when the client connects to the server.</td></tr><tr><td>CStartServerParameter.m_enableP2PEncryptedMessaging=false. P2P Messaging can not encrypted</td><td>ErrorType_EncryptFail</td><td>OnError occurs when sending a message</td></tr><tr><td>Current loaded data owner as DB cache client denied the handover.</td><td>ErrorType_PermissionDenied</td><td>DBcache client fails to load data after making a request to the server</td></tr><tr><td>Data (root=s) is already isolated.</td><td>ErrorType_PermissionDenied</td><td>Adding to the list of failures when loading data from the DB cache server</td></tr><tr><td>decryptCount1 read failed</td><td>ErrorType_DecryptFail</td><td>Decryption fails when receiving an encrypted message</td></tr><tr><td>decryption failure 1</td><td>ErrorType_DecryptFail</td><td>Discarding messages when they are out of order after receiving encrypted messages</td></tr><tr><td>Decryption result is larger! Memory corruption may occur</td><td>ErrorType_DecryptFail</td><td>Decryption fails when the decrypted block is larger than the encrypted block</td></tr><tr><td>DenyUnloadData is called for not-loaded data.</td><td>ErrorType_LoadedDataNotFound</td><td>OnWarning occurs when DBCache2 client requests data unload from server</td></tr><tr><td>DNS lookup failure. error code=(Error Code)</td><td>ErrorType_TCPConnectFailure</td><td>Failed to look up server IP from client</td></tr><tr><td>Error</td><td>ErrorType_DecryptFail</td><td>Decryption fails using RSA algorithm</td></tr><tr><td>Error : NotifyAddDataSuccess: InsertChild failed.</td><td>ErrorType_Unexpected</td><td>OnWarning occurs on DBCache2 server</td></tr><tr><td>Error : NotifyAddDataSuccess: OwnerNode not found.</td><td>ErrorType_Unexpected</td><td>OnWarning occurs on DBCache2 server</td></tr><tr><td>Error : UnilateralMoveData MovePropNode Fail</td><td>ErrorType_ValueNotExist</td><td>OnWarning occurs in DBCache2 client</td></tr><tr><td>Error : UnilateralMoveData RemoveNode Fail</td><td>ErrorType_Unexpected</td><td>OnWarning occurs in DBCache2 client</td></tr><tr><td>Error : UnilateralRemoveData failed to remove node.</td><td>ErrorType_Unexpected</td><td>OnWarning occurs in DBCache2 client</td></tr><tr><td>Failed to create credential.</td><td>ErrorType_EncryptFail</td><td>Client fails to communicate on first contact with server</td></tr><tr><td>Failed to create SessionKey.</td><td>ErrorType_EncryptFail</td><td>Client fails to communicate on first contact with server</td></tr><tr><td>FATAL: new UDP socket - Cannot create UDP socket! Cannot get TCP NIC address (AddrPort).</td><td>ErrorType_LocalSocketCreationFailed</td><td>Failed to create a UDP socket to the server when creating a UDP socket on the client</td></tr><tr><td>I/O length=d, error code=d</td><td>ErrorType_DisconnectFromRemote</td><td>Terminating a connection during socket cleanup</td></tr><tr><td>Incorrect Packet</td><td>ErrorType_DecryptFail</td><td>Failed decryption by checking for decryption attempts and packet tampering using the RSA algorithm</td></tr><tr><td>input is NULL.</td><td>ErrorType_DecryptFail</td><td>Decryption failed because no encrypted message was entered</td></tr><tr><td>input is NULL.</td><td>ErrorType_EncryptFail</td><td>Encryption fails when there is nothing to encrypt</td></tr><tr><td>input length is invalid.</td><td>ErrorType_DecryptFail</td><td>Decryption failed because the length of the encrypted message was too short</td></tr><tr><td>insufficient output buffer.</td><td>ErrorType_EncryptFail</td><td>Encryption failed because the space to write the encrypted message is smaller than the size of the original message</td></tr><tr><td>invalid input length.</td><td>ErrorType_EncryptFail</td><td>Encryption failed because the original message block size is less than zero</td></tr><tr><td>Invalid Root Table Name.</td><td>ErrorType_UserRequested</td><td>Add to fail list on DBCache2 server</td></tr><tr><td>is isolated.</td><td>ErrorType_UserRequested</td><td>Abandon loading data from the DBCache2 server</td></tr><tr><td>key for fast encryption does not exist.</td><td>ErrorType_DecryptFail</td><td>Decryption fails because the key for decryption is missing</td></tr><tr><td>key for fast encryption does not exist.</td><td>ErrorType_EncryptFail</td><td>Encryption fails because there is no key for encryption</td></tr><tr><td>Loading data failure. s</td><td>ErrorType_Unexpected</td><td>DBCache2 server failed to load data from DB, add to fail list</td></tr><tr><td>Make sure that enableP2PEncryptedMessaging is true.</td><td>ErrorType_DecryptFail</td><td>Decryption fails because there is no key for decryption</td></tr><tr><td>MessageType:d at location NC.PNL</td><td>ErrorType_InvalidPacketFormat</td><td>OnError is raised after receiving a message from the client</td></tr><tr><td>NLM1</td><td>ErrorType_InvalidLicense</td><td>Unable to connect to server and client due to license issues</td></tr><tr><td>Non-exclusive data access is denied.</td><td>ErrorType_PermissionDenied</td><td>Failed to load data on a DBCache2 server that did not allow non-exclusive access to data</td></tr><tr><td>NPDC</td><td>ErrorType_NotifyServerDeniedConnection</td><td>When connecting from the client to the server, the connection fails and an OnWarning occurs.</td></tr><tr><td>NPVM1</td><td>ErrorType_ProtocolVersionMismatch</td><td>Connection fails if the client uses a different version than the server when connecting to the server</td></tr><tr><td>output is NULL.</td><td>ErrorType_DecryptFail</td><td>Decryption failed with NULL space to write the decrypted message</td></tr><tr><td>output is NULL.</td><td>ErrorType_EncryptFail</td><td>Encryption fails because there is no space to store the encrypted output</td></tr><tr><td>output length is invalid.</td><td>ErrorType_DecryptFail</td><td>Decryption failed because the space to write the decrypted message is smaller than the size of the encrypted message</td></tr><tr><td>Packet compression failed! Error code=d</td><td>ErrorType_CompressFail</td><td>Message compression fails when sending message, OnError occurs</td></tr><tr><td>Please Check Encrypt Error CStartServerParameter</td><td>ErrorType_EncryptFail</td><td>Encryption fails when sending data from the client</td></tr><tr><td>Received datagram from UDP became inconsistent</td><td>ErrorType_InvalidPacketFormat, ErrorType_TooLargeMessageDetected</td><td>OnWarning occurs when receiving UDP message</td></tr><tr><td>Received stream from TCP server became inconsistent</td><td>ErrorType_InvalidPacketFormat, ErrorType_TooLargeMessageDetected</td><td>Terminate the connection when a TCP message is received</td></tr><tr><td>Remote detected no receive.</td><td>ErrorType_ConnectServerTimeout</td><td>Connection fails when a client requests a connection to the server</td></tr><tr><td>RMI (name=s)</td><td>ErrorType_NotImplementedRmi</td><td>RMI Call Failure</td></tr><tr><td>RootUUID is not valid</td><td>ErrorType_UserRequested</td><td>Failed to load data from the DBCache2 server</td></tr><tr><td>RootUUID not found.</td><td>ErrorType_LoadedDataNotFound</td><td>OnException occurs when data load fails from DBCache2 server</td></tr><tr><td>RootUUID not found. s</td><td>ErrorType_LoadedDataNotFound</td><td>OnException occurs when data load fails from DBCache2 server</td></tr><tr><td>sendQueue dBytes</td><td>ErrorType_SendQueueIsHeavy</td><td>OnWarning occurs when the transmission queue is filled with too many messages</td></tr><tr><td>Server UDP holepunch OK, but we cannot do DNS look up. Error code = d</td><td>ErrorType_Unexpected</td><td>OnError occurs when hole-punching from the client to the server</td></tr><tr><td>Socket accept fail. socket error=(SocketErrorCode)</td><td>ErrorType_LocalSocketCreationFailed</td><td>Socket creation failed, error code is based on WSAGetLastError()</td></tr><tr><td>Stream Extract Error at Reliable UDP</td><td>ErrorType_InvalidPacketFormat, ErrorType_TooLargeMessageDetected</td><td>OnError occurs when sending and receiving reliable UDP from the client</td></tr><tr><td>TCP graceful disconnect, NetClient.Disconnect() or NetServer.CloseConnection() has been called.</td><td>ErrorType_DisconnectFromLocal</td><td>Failed to receive a message while processing connection termination (after calling Disconnect, CloseConnection)</td></tr><tr><td>TCP graceful disconnect.</td><td>ErrorType_DisconnectFromRemote</td><td>Terminating a connection during socket cleanup</td></tr><tr><td>The data does not exist.</td><td>ErrorType_LoadedDataNotFound</td><td>DBCache2 client fails to load data</td></tr><tr><td>time out</td><td>ErrorType_TimeOut</td><td>AddData Failed on DBCache2 Client</td></tr><tr><td>Too long elapsed time in NetClient heartbeat thread (%3.31f sec)</td><td>ErrorType_TooSlowHeartbeatWarning</td><td>When the client connects to the server, the connection fails and OnError occurs</td></tr><tr><td>Trial count:d, Arbitrary port number used: d</td><td>Error_NoneAvailableInPortPool</td><td>If the port set during UDP hole punching is unavailable, random UDP port binding occurs and OnWarning occurs</td></tr><tr><td>UDP socket for peer connection</td><td>ErrorType_LocalSocketCreationFailed</td><td>When creating a UDP socket on the client, UDP socket creation for p2p fails, OnWarning occurs</td></tr><tr><td>UDP socket for server connection</td><td>ErrorType_LocalSocketCreationFailed</td><td>When creating a UDP socket on the client, the creation of a UDP socket towards the server fails and OnWarning occurs</td></tr><tr><td>Unexpected: TCP-connected socket has no local address</td><td>ErrorType_UnknownAddrPort</td><td>OnError occurs when the client receives its local address abnormally after connecting to the server</td></tr><tr><td>We stopped socket I/O already.</td><td>ErrorType_DisconnectFromLocal</td><td>Connection terminated during socket cleanup</td></tr><tr><td>ExclusiveLoadNewData cannot be used when loading data that already exists.</td><td>ErrorType_AlreadyExists</td><td>Load failure when loading data from DBCacheServer</td></tr></tbody></table>

<br>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.proudnet.com/proudnet.eng/proudnet-note/notes/error_message_list.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
